/***************************************************************************                                                  *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

 #include <kapp.h>
 #include <qpainter.h>
 #include <qpixmap.h>
 #include <kiconloader.h>
 #include <klocale.h>
 #include <qcursor.h>

#include "dockwidget.h"

DockWidget::DockWidget(QWidget *parent, const char *name)
 : KSystemTray(parent, name), docked(false)
{
contextMenu()-> setCheckable(true);
contextMenu()->insertItem(i18n("Configure Kollins"), parent, SLOT(ConfigureKollins()), 0, 0, -1);
contextMenu()->insertItem(i18n("Clipboard Tracking"), parent, SLOT(ClipboardTracking()), 0, 1, -1);

connect(this, SIGNAL(trackingChanged() ), parent, SLOT(ClipboardTracking()));
connect(this, SIGNAL(miniRest() ), this, SLOT(toggleMinimizeRestore()));
}


void DockWidget::updateMenu(bool ch)
{
contextMenu()->setItemChecked(1, ch);
tracking = ch;
update();
}


DockWidget::~DockWidget()
{
}

void DockWidget::dock()
{
if (!docked)
  {
  docked = true;
  this->show();
  }
}

void DockWidget::undock()
{
if (docked)
  {
  docked = false;
  this->hide();
  }
}


void DockWidget::paintEvent(QPaintEvent*)
{
  int x(0),y(0);
  QPixmap icon = SmallIcon("kollins", 0, (tracking ? KIcon::ActiveState : KIcon::DisabledState) );
  QSize s(icon.size());
  if(s.width() < 24) x = (24 - s.width())/2;
  if(s.height() < 24) y = (24 - s.height())/2;
  bitBlt(this, x, y, &icon);
}


void DockWidget::mousePressEvent( QMouseEvent *e )
{
if ( e->button() == QMouseEvent::MidButton )
	emit trackingChanged ();
 else if ( e->button() == QMouseEvent::RightButton )
	contextMenu()->exec(QCursor::pos());
else if (e->button() == QMouseEvent::LeftButton )
	emit miniRest();
}
