
#ifndef _KOLLINS_H_
#define _KOLLINS_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <qwidget.h>
#include <klistbox.h>
#include <klineedit.h>
#include <kmenubar.h>
#include <ktoolbar.h>
#include <qtoolbutton.h>
#include <qclipboard.h>
#include <qcursor.h>

#include <qtextbrowser.h>
#include <qpopupmenu.h>

#include <qtimer.h>
#include <qsplitter.h>
#include <kaction.h>

#include <kprinter.h>

#include "dockwidget.h"
#include "ydpconfigure.h"
#include "ydpdictionary.h"
#include "kydpconfig.h"
#include "dynamictip.h"


class DockWidget;
class kydpConfig;

class Kollins : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    Kollins();

    /**
     * Default Destructor
     */
    virtual ~Kollins();

    public slots:
    void contextMenu();

    private:

    DockWidget *ksdock;
    kydpConfig *config;
    QClipboard  *cb;
    QTimer *m_checkTimer;

    KListBox *dictList;
    KLineEdit *wordInput;
    QTextBrowser *RTFOutput;
    KMenuBar  *menu;
    KToolBar *mainToolBar;
    QSplitter *splitterH;

    ydpDictionary *myDict;

    QPopupMenu *m_popup;

    DynamicTip * t;

    bool dialogActiv; //obejscie bledu w kde ?

    void UpdateLook();
    void UpdateFonts();

    private slots:

    void test();
    void clearInput();
    void InitActions();
    void Configure(bool status);
    void ConfigureKollins();
    void updateText( const QString & href );
    void ClipboardTracking();
    void updateGeometry();
    void NewFromLine(const QString &newText);
    void slotSelectionChanged() { clipboardSignalArrived( true ); }
    void slotClipboardChanged() { clipboardSignalArrived( false ); }
    void newClipData();
    void onViewToolbar();
    void onViewMenubar();
    void ConfigureToolbars();
    void ConfigureShortcuts();
    void SwapPolToEng();
    void SwapEngToPol();
    void SwapGerToPol();
    void SwapPolToGer();
    void SwapLang(bool direction, int lang);
    void PasteClippboard(QString haslo);
    void NewDefinition (int index);
    void PlaySelected (int index);			/* dbl click or return to play */
    void PlayCurrent ();
    void UpdateWinTitle(const QString& contents);
    void onPrint();
    void UpdateTip();
    void reverseDirection();

    protected:
    void showEvent(QShowEvent *e);
    void hideEvent(QHideEvent *e);
    void clipboardSignalArrived( bool selectionMode );
    void checkClipData( const QString& text );
    KToggleAction* toggleAction(const char* name) const
    {return (KToggleAction*) action(name);}
};

#endif // _KOLLINS_H_
