/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "kydpconfig.h"

kydpConfig::kydpConfig()
{
}


kydpConfig::~kydpConfig()
{
}

void kydpConfig::load()
{
QString id;

KConfig* config = kapp->config();

setDefaultConfiguration();

config->setGroup("Paths");
topPathEn = config->readEntry("pathToEnglishDictionary", topPathEn);
topPathDe = config->readEntry("pathToGermanDictionary", topPathDe);
cdPathEn = config->readEntry("pathToEnglishAudio", cdPathEn);
cdPathDe = config->readEntry("pathToGermanAudio", cdPathDe);
player = config->readEntry("pathToPlayer", player);
kBckgrndPix = config->readEntry("backgroundPicture", kBckgrndPix); // wyrzucic !
recentImages = config->readListEntry("recentImages");

config->setGroup("Main options");
enableEnglishDict = config->readBoolEntry("enableEnglishDict", enableEnglishDict);
enableGermanDict = config->readBoolEntry("enableGermanDict", enableGermanDict);
toPolish = config->readBoolEntry("toPolish", toPolish);
useEnglish = config->readBoolEntry("useEnglish", useEnglish);

config->setGroup("Geometry");
geometry = config->readRectEntry("windowGeometry", &geometry);
lst = config->readIntListEntry( "splitterSizes" );

config->setGroup("Text colors");
kFontKolor4 = config->readEntry("plain", kFontKolor4);
kFontKolor1 = config->readEntry("translation", kFontKolor1);
kFontKolor2 = config->readEntry("description", kFontKolor2);
kFontKolor3 = config->readEntry("example", kFontKolor3);

config->setGroup("Miscellanous options");
clipTracking = config->readBoolEntry("clipboardTracking", clipTracking);
italicFont = config->readBoolEntry("italicFont", italicFont);
toolTips = config->readBoolEntry("toolTips", toolTips);
autoPlay = config->readBoolEntry("autoPlay", autoPlay);
minimizeToTray = config->readBoolEntry("minimizeToTray", minimizeToTray);
}

void kydpConfig::save()
{
KConfig *config = kapp->config();

config->setGroup("Paths");
config->writeEntry("pathToEnglishDictionary", topPathEn);
config->writeEntry("pathToGermanDictionary", topPathDe);
config->writeEntry("pathToEnglishAudio", cdPathEn);
config->writeEntry("pathToGermanAudio", cdPathDe);
config->writeEntry("pathToPlayer", player);
config->writeEntry("backgroundPicture", kBckgrndPix);
config->writeEntry("recentImages", recentImages);

config->setGroup("Main options");
config->writeEntry("enableEnglishDict", enableEnglishDict);
config->writeEntry("enableGermanDict", enableGermanDict);
config->writeEntry("toPolish", toPolish);
config->writeEntry("useEnglish", useEnglish);

config->setGroup("Geometry");
config->writeEntry("windowGeometry", geometry);
config->writeEntry( "splitterSizes", lst );

config->setGroup("Text colors");
config->writeEntry("plain", kFontKolor4);
config->writeEntry("translation", kFontKolor1);
config->writeEntry("description", kFontKolor2);
config->writeEntry("example", kFontKolor3);

config->setGroup("Miscellanous options");
config->writeEntry("clipboardTracking", clipTracking);
config->writeEntry("italicFont", italicFont);
config->writeEntry("toolTips", toolTips);
config->writeEntry("autoPlay", autoPlay);
config->writeEntry("minimizeToTray", minimizeToTray);

config->sync();
}

void kydpConfig::setDefaultConfiguration()
{

topPathEn = "/usr/share/ydpdict/";
topPathDe = "/usr/share/ydpdict/";
cdPathEn = "/mnt/cdrom/";
cdPathDe = "/mnt/cdrom/";
player = "/usr/bin/play";
kBckgrndPix = "NoBackground";

geometry = QRect(0, 0, 640, 165);

toPolish = true;
useEnglish = true;
enableEnglishDict = false;
enableGermanDict = false;

kFontKolor1 = "#C00000";
kFontKolor2 = "#0000ff";
kFontKolor3 = "#736324";
kFontKolor4 = "#000000";

clipTracking = true;
italicFont = false;
toolTips = true;
autoPlay= false;
minimizeToTray = true;
}
