
#include "kollins.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char *description =
    I18N_NOOP("Frontend to YDP Collins Dictionary.");

static const char *version = "0.2";

static KCmdLineOptions options[] =
{
//    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    { 0, 0, 0 }
};

int main(int argc, char **argv)
{
    KAboutData about("kollins", I18N_NOOP("kollins"), version, description,
                     KAboutData::License_GPL, "(C) 2003 Andrzej Para", 0, 0, "kulozik@op.pl");
    about.addAuthor( "Andrzej Para", 0, "kulozik@op.pl" );
    about.addCredit("Wojtek Kaniewski",  I18N_NOOP("Author of ydpdict"), "wojtekka@dione.ids.pl");
    about.addCredit("Maciej Witkowiak",  I18N_NOOP("Author of kydpdict"), "ytm@friko.onet.pl",
    "http://members.elysium.pl/ytm/html/kydpdict.html");
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;
    Kollins *mainWin = 0;

    if (app.isRestored())
    {
        RESTORE(Kollins);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        // TODO: do something with the command line args here

        mainWin = new Kollins();
        app.setMainWidget( mainWin );
        mainWin->show();

        args->clear();
    }

    int ret = app.exec();

    delete mainWin;
    return ret;
}
