/***************************************************************************                                             *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "ydpconfigure.h"

ydpConfigure::ydpConfigure(kydpConfig *globalconfig, QWidget *parent, const char *name, bool modal)
 : QDialog(parent, name, modal)
{
setFixedSize(400,250);
setCaption( i18n("Configure Kollins") );

defaults = new QPushButton( this, "defaults" );
defaults->setText(i18n("Defaults") );
defaults->setGeometry(10,217,81,26);

cancel = new QPushButton( this, "cancel" );
cancel->setText( i18n("Cancel") );
cancel->setGeometry(310,217,81,26);

ok = new QPushButton( this, "Ok" );
ok->setText( i18n("Ok") );
ok->setGeometry(210,217,81,26);

TabWidget1 = new QTabWidget( this, "TabWidget1" );
TabWidget1->setGeometry(10,10,381,200);

tab1 = new QWidget( TabWidget1, "tab1" );

checkBox1a = new QCheckBox(i18n("Use English/Polish Dictionary"), tab1, "checkBox1a");
checkBox1a->setGeometry(8,6,350,20);
checkBox1b = new QCheckBox(i18n("Use German/Polish Dictionary"), tab1, "checkBox1b");
checkBox1b->setGeometry(8,88,350,20);

GroupBox1 = new QGroupBox( tab1, "GroupBox1" );
GroupBox1->setTitle( i18n("Path to English/Polish dictionary files") );
GroupBox1->setGeometry(8,30,361,50);

dictionaryUrlEnPl = new KURLRequester(GroupBox1, "dictionaryUrlEnPl");
dictionaryUrlEnPl->setGeometry( 10, 16, 340, 26 );
dictionaryUrlEnPl->setMode(KFile::Directory);

GroupBox2 = new QGroupBox( tab1, "GroupBox2" );
GroupBox2->setTitle( i18n("Path to German/Polish dictionary files") );
GroupBox2->setGeometry(8,112,361,50);

dictionaryUrlDePl = new KURLRequester(GroupBox2, "dictionaryUrlDePl");
dictionaryUrlDePl->setGeometry( 10, 16, 340, 26 );
dictionaryUrlDePl->setMode(KFile::Directory);

tab2 = new QWidget( TabWidget1, "tab2" );

GroupBox3 = new QGroupBox( tab2, "GroupBox3" );
GroupBox3->setTitle( i18n("Path to English/Polish audio files") );
GroupBox3->setGeometry(8,5,361,50);

audioUrlEnPl = new KURLRequester(GroupBox3, "audioUrlEnPl");
audioUrlEnPl->setGeometry( 10, 16, 340, 26 );
audioUrlEnPl->setMode(KFile::Directory);

GroupBox4 = new QGroupBox( tab2, "GroupBox4" );
GroupBox4->setTitle( i18n("Path to German/Polish audio files") );
GroupBox4->setGeometry(8,59,361,50);

audioUrlDePl = new KURLRequester(GroupBox4, "audioUrlDePl");
audioUrlDePl->setGeometry( 10, 16, 340, 26 );
audioUrlDePl->setMode(KFile::Directory);

GroupBox5 = new QGroupBox( tab2, "GroupBox5" );
GroupBox5->setTitle( i18n("Path to audio player") );
GroupBox5->setGeometry(8,111,361,50);

playerUrl = new KURLRequester(GroupBox5, "playerUrl");
playerUrl->setGeometry( 10, 16, 340, 26 );
playerUrl->setFilter("application/x-executable");

tab3 = new QWidget( TabWidget1, "tab3" );

textLabel2 = new QLabel(i18n("Choose qualificator color"), tab3, "textLabel2");
textLabel2->setGeometry(6,36,150,22);
textLabel1 = new QLabel(i18n("Choose translation color"), tab3, "textLabel1");
textLabel1->setGeometry(6,62,150,22);
textLabel3 = new QLabel(i18n("Choose example color"), tab3, "textLabel3");
textLabel3->setGeometry(6,88,150,22);
textLabel4 = new QLabel(i18n("Choose background"), tab3, "textLabel4");
textLabel4->setGeometry(6,114,150,22);
textLabel5 = new QLabel(i18n("Choose plain text color"), tab3, "textLabel5");
textLabel5->setGeometry(6,10,150,22);

changeFont1 = new KColorButton ( tab3, "changeFont1" );
changeFont1->setGeometry(162,62,40,22);
changeFont2 = new KColorButton ( tab3, "changeFont2" );
changeFont2->setGeometry(162,36,40,22);
changeFont3 = new KColorButton ( tab3, "changeFont3" );
changeFont3->setGeometry(162,88,40,22);
changeFont4 = new KColorButton ( tab3, "changeFont4" );
changeFont4->setGeometry(162,10,40,22);

exampleLabel1 = new QTextEdit (tab3, "exampleLabel1");
exampleLabel1->setAlignment( Qt::AlignCenter );
exampleLabel1->setFrameStyle( QFrame::Box | QFrame::Plain);
exampleLabel1->setLineWidth( 1 );
exampleLabel1->setGeometry(208,10,160,150);
exampleLabel1-> setReadOnly(TRUE);

changeBackground = new KPushButton(i18n("..."), tab3, "changeBackground");
changeBackground->setGeometry(162,138,40,22);

tab4 = new QWidget( TabWidget1, "tab4" );
checkBox2 = new QCheckBox(i18n("Enable clipboard tracking"), tab4, "checkBox2");
checkBox2->setGeometry(10,14,350,20);
checkBox3 = new QCheckBox(i18n("Enable italic font"), tab4, "checkBox3");
checkBox3->setGeometry(10,44,350,20);
checkBox4 = new QCheckBox(i18n("Enable tooltips"), tab4, "checkBox4");
checkBox4->setGeometry(10,74,350,20);
checkBox5 = new QCheckBox(i18n("Enable autoplay"), tab4, "checkBox5");
checkBox5->setGeometry(10,104,350,20);
checkBox6 = new QCheckBox(i18n("Minimize to tray"), tab4, "checkBox6");
checkBox6->setGeometry(10,134,350,20);

backgroundUrl = new KComboBox(tab3, "backgroundUrl");
backgroundUrl->setGeometry(6,138,150,22);//138
backgroundUrl->setMaxCount(5); //**********************************

TabWidget1->insertTab( tab1, i18n("Dictionary") );
TabWidget1->insertTab( tab2, i18n("Audio") );
TabWidget1->insertTab( tab3, i18n("Colors") );
TabWidget1->insertTab( tab4, i18n("Miscellaneous") );

QWhatsThis::add(GroupBox1,
i18n("Path to directory with files: \"dict100.idx\", \"dict101.idx\", \"dict100.dat\", \"dict101.dat\"."));
QWhatsThis::add(GroupBox2,
i18n("Path to directory with files: \"dict200.idx\", \"dict201.idx\", \"dict200.dat\", \"dict201.dat\"."));
QWhatsThis::add(GroupBox3,
i18n("Path to directory with directories: \"S000\", \"S001\", \"S002\", etc. that includes english audio data."));
QWhatsThis::add(GroupBox4,
i18n("Path to directory with directories: \"S000\", \"S001\", \"S002\", etc. that includes german audio data."));

connect(changeFont1, SIGNAL(clicked()), this, SLOT(UpdateText()));
connect(changeFont2, SIGNAL(clicked()), this, SLOT(UpdateText()));
connect(changeFont3, SIGNAL(clicked()), this, SLOT(UpdateText()));
connect(changeFont4, SIGNAL(clicked()), this, SLOT(UpdateText()));
connect(changeBackground, SIGNAL(clicked()), this, SLOT(UpdateText()));
connect(backgroundUrl, SIGNAL(activated( int ) ), this, SLOT(UpdateCombo( int )));
connect(changeBackground, SIGNAL(clicked() ), this, SLOT(NewBackground()));

connect(checkBox1a, SIGNAL(stateChanged( int)), this, SLOT(updateCheck1a(int)));
connect(checkBox1b, SIGNAL(stateChanged( int)), this, SLOT(updateCheck1b(int)));

connect( ok, SIGNAL( clicked() ), this, SLOT( accept() ) );
connect( cancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
connect( defaults, SIGNAL( clicked() ), this, SLOT( WriteDefaults() ) );

config = globalconfig;
playerUrl->setURL(config->player);
dictionaryUrlEnPl->setURL(config->topPathEn);
dictionaryUrlDePl->setURL(config->topPathDe);
audioUrlEnPl->setURL(config->cdPathEn);
audioUrlDePl->setURL(config->cdPathDe);
changeFont1->setColor(QColor(config->kFontKolor1));
changeFont2->setColor(QColor(config->kFontKolor2));
changeFont3->setColor(QColor(config->kFontKolor3));
changeFont4->setColor(QColor(config->kFontKolor4));

backgroundUrl->insertStringList(config->recentImages);
backgroundUrl->setCurrentItem(0);

if(QString::compare(backgroundUrl->currentText(),"NoBackground") ) {
	backgroundUrl->insertItem("NoBackground", 0);
	if(backgroundUrl->count() > 1)
		backgroundUrl->setCurrentItem(1);
}

//set up controls
checkBox1a->setChecked(config->enableEnglishDict);
checkBox1b->setChecked(config->enableGermanDict);
updateCheck1a(2*checkBox1a->isChecked());
updateCheck1b(2*checkBox1b->isChecked());
checkBox2->setChecked(config->clipTracking);
checkBox3->setChecked(config->italicFont);
checkBox4->setChecked(config->toolTips);
checkBox5->setChecked(config->autoPlay);
checkBox6->setChecked(config->minimizeToTray);
UpdateText();
UpdateBackground(backgroundUrl->currentText());

}

void ydpConfigure::NewBackground()
{
KURL adr;
adr = KFileDialog::getImageOpenURL("/", this, "Choose background image");
if(adr.isValid()) {
	backgroundUrl->insertItem(adr.path(), 1);
	if(backgroundUrl->count() > 6 )
		backgroundUrl->removeItem(backgroundUrl->count()-1);

	backgroundUrl->setCurrentItem(1);
}
    UpdateBackground(backgroundUrl->currentText());
}

void ydpConfigure::WriteDefaults()
{
kydpConfig *cnf = new kydpConfig;

cnf->setDefaultConfiguration();

dictionaryUrlEnPl->setURL(cnf->topPathEn);
dictionaryUrlDePl->setURL(cnf->topPathDe);
audioUrlEnPl->setURL(cnf->cdPathEn);
audioUrlDePl->setURL(cnf->cdPathDe);
playerUrl->setURL(cnf->player);
changeFont1->setColor(QColor(cnf->kFontKolor1));
changeFont2->setColor(QColor(cnf->kFontKolor2));
changeFont3->setColor(QColor(cnf->kFontKolor3));
changeFont4->setColor(QColor(cnf->kFontKolor4));
checkBox2->setChecked(cnf->clipTracking);
checkBox3->setChecked(cnf->italicFont);
checkBox4->setChecked(cnf->toolTips);
checkBox5->setChecked(cnf->autoPlay);
checkBox6->setChecked(cnf->minimizeToTray);
UpdateText();
backgroundUrl->setCurrentItem(0);
UpdateBackground(backgroundUrl->currentText());
delete cnf;
}

void ydpConfigure::UpdateText()
{
    QString label;

    exampleLabel1->setLinkUnderline(FALSE);

label = "<qt type=\"page\"><font color=" + changeFont4->color().name() +"><b>ably</b>[eibli]<br><br><i><font color="
+changeFont2->color().name() +">adv</font></i><br><font color=" +    changeFont1->color().name() +
">umiejtnie</font>,<font color=" + changeFont1->color().name() +
">zrcznie</font><br><table cellspacing=0><tr><td width=25></td><td><font color="+ changeFont3->color().name() +
">They were ably supported by the Communist Party.</font></td></tr></table></font></qt>";
exampleLabel1->setText(label.fromLocal8Bit(label));
}

void ydpConfigure::UpdateBackground(const QString& background)
{
    QPixmap pixmap;
    QBrush paper;

    if(pixmap.load(background) ) {
	paper.setPixmap(pixmap);
	exampleLabel1->setPaper( paper );
    } else {
    	exampleLabel1->setPaper( white );
    }
}

void ydpConfigure::UpdateCombo(int index)
{
backgroundUrl->insertItem(backgroundUrl->currentText(), 1);
backgroundUrl->removeItem(index + 1);
UpdateBackground(backgroundUrl->text(index == 0 ? 0 : 1));
}

void ydpConfigure::updateCheck1a(int state)
{
switch (state) {
	case 0:
	GroupBox1->setEnabled(false);
	GroupBox3->setEnabled(false);
	break;
	case 2:
	GroupBox1->setEnabled(true);
	GroupBox3->setEnabled(true);
	break;
	default:
	break;
	}
}

void ydpConfigure::updateCheck1b(int state)
{
switch (state) {
	case 0:
	GroupBox2->setEnabled(false);
	GroupBox4->setEnabled(false);
	break;
	case 2:
	GroupBox2->setEnabled(true);
	GroupBox4->setEnabled(true);
	break;
	default:
	break;
	}
}

ydpConfigure::~ydpConfigure()
{
if (result()==Accepted) {
	config->kFontKolor1 = changeFont1->color().name();
	config->kFontKolor2 = changeFont2->color().name();
	config->kFontKolor3 = changeFont3->color().name();
	config->kFontKolor4 = changeFont4->color().name();
	config->kBckgrndPix = backgroundUrl->text(backgroundUrl->currentItem() == 0 ? 0 : 1);
	config->topPathEn = dictionaryUrlEnPl->url();
	config->topPathDe = dictionaryUrlDePl->url();
	config->cdPathEn = audioUrlEnPl->url();
	config->cdPathDe = audioUrlDePl->url();
	config->player = playerUrl->url();
	config->enableEnglishDict = checkBox1a->isChecked();
	config->enableGermanDict = checkBox1b->isChecked();
	config->clipTracking = checkBox2->isChecked();
	config->italicFont = checkBox3->isChecked();
	config->toolTips = checkBox4->isChecked();
	config->autoPlay = checkBox5->isChecked();
	config->minimizeToTray = checkBox6->isChecked();
	if(QString::compare(backgroundUrl->currentText(),"NoBackground"))
		backgroundUrl->removeItem(0);
	config->recentImages.clear();
	for(int i = 0; i < backgroundUrl->count(); i++)
		config->recentImages.append(backgroundUrl->text(i));
}

}
