/***************************************************************************                          *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef YDPCONFIGURE_H
#define YDPCONFIGURE_H

#include <qdialog.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <kurlrequester.h>
#include <kfiledialog.h>
#include <qtextedit.h>
#include <qtabwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <kcolorbutton.h>
#include <qpixmap.h>
#include <kcombobox.h>
#include <klocale.h>
#include <qwhatsthis.h>

#include "kydpconfig.h"

class ydpConfigure : public QDialog
{
Q_OBJECT
public:
    ydpConfigure(kydpConfig *config, QWidget *parent = 0, const char *name = 0, bool modal = FALSE);

    ~ydpConfigure();

private:
    QTabWidget *TabWidget1;
    QWidget *tab1, *tab2, *tab3, *tab4;
    QGroupBox *GroupBox1, *GroupBox2, *GroupBox3, *GroupBox4, *GroupBox5;
    QPushButton *cancel;
    QPushButton *ok;
    QPushButton *defaults;
    QLabel *textLabel1;
    QLabel *textLabel2;
    QLabel *textLabel3;
    QLabel *textLabel4;
    QLabel *textLabel5;
    KColorButton *changeFont1;
    KColorButton *changeFont2;
    KColorButton *changeFont3;
    KColorButton *changeFont4;
    QTextEdit *exampleLabel1;
    QPushButton *changeBackground;
    QCheckBox *checkBox1a;
    QCheckBox *checkBox1b;
    QCheckBox *checkBox2;
    QCheckBox *checkBox3;
    QCheckBox *checkBox4;
    QCheckBox *checkBox5;
    QCheckBox *checkBox6;
    KURLRequester *dictionaryUrlEnPl;
    KURLRequester *audioUrlEnPl;
    KURLRequester *dictionaryUrlDePl;
    KURLRequester *audioUrlDePl;
    KURLRequester *playerUrl;
    KComboBox *backgroundUrl;

    kydpConfig *config;

    private slots:
    void WriteDefaults();
    void NewBackground();
    void UpdateText();
    void UpdateBackground(const QString & );
    void UpdateCombo(int);
    void updateCheck1a(int state);
    void updateCheck1b(int state);

};

#endif
